diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/meta.php ./wordpress-3.3/wp-includes/meta.php
*** ./wordpress-3.2.1/wp-includes/meta.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/meta.php	2011-10-24 14:13:23.000000000 -0500
***************
*** 26,32 ****
   * @param bool $unique Optional, default is false.  Whether the specified metadata key should be
   * 		unique for the object.  If true, and the object already has a value for the specified
   * 		metadata key, no change will be made
!  * @return bool True on successful update, false on failure.
   */
  function add_metadata($meta_type, $object_id, $meta_key, $meta_value, $unique = false) {
  	if ( !$meta_type || !$meta_key )
--- 26,32 ----
   * @param bool $unique Optional, default is false.  Whether the specified metadata key should be
   * 		unique for the object.  If true, and the object already has a value for the specified
   * 		metadata key, no change will be made
!  * @return bool The meta ID on successful update, false on failure.
   */
  function add_metadata($meta_type, $object_id, $meta_key, $meta_value, $unique = false) {
  	if ( !$meta_type || !$meta_key )
***************
*** 49,55 ****
  
  	$check = apply_filters( "add_{$meta_type}_metadata", null, $object_id, $meta_key, $meta_value, $unique );
  	if ( null !== $check )
! 		return (bool) $check;
  
  	if ( $unique && $wpdb->get_var( $wpdb->prepare(
  		"SELECT COUNT(*) FROM $table WHERE meta_key = %s AND $column = %d",
--- 49,55 ----
  
  	$check = apply_filters( "add_{$meta_type}_metadata", null, $object_id, $meta_key, $meta_value, $unique );
  	if ( null !== $check )
! 		return $check;
  
  	if ( $unique && $wpdb->get_var( $wpdb->prepare(
  		"SELECT COUNT(*) FROM $table WHERE meta_key = %s AND $column = %d",
***************
*** 61,80 ****
  
  	do_action( "add_{$meta_type}_meta", $object_id, $meta_key, $_meta_value );
  
! 	$wpdb->insert( $table, array(
  		$column => $object_id,
  		'meta_key' => $meta_key,
  		'meta_value' => $meta_value
  	) );
  
  	wp_cache_delete($object_id, $meta_type . '_meta');
- 	// users cache stores usermeta that must be cleared.
- 	if ( 'user' == $meta_type )
- 		clean_user_cache($object_id);
  
! 	do_action( "added_{$meta_type}_meta", $wpdb->insert_id, $object_id, $meta_key, $_meta_value );
  
! 	return true;
  }
  
  /**
--- 61,82 ----
  
  	do_action( "add_{$meta_type}_meta", $object_id, $meta_key, $_meta_value );
  
! 	$result = $wpdb->insert( $table, array(
  		$column => $object_id,
  		'meta_key' => $meta_key,
  		'meta_value' => $meta_value
  	) );
  
+ 	if ( ! $result )
+ 		return false;
+ 
+ 	$mid = (int) $wpdb->insert_id;
+ 
  	wp_cache_delete($object_id, $meta_type . '_meta');
  
! 	do_action( "added_{$meta_type}_meta", $mid, $object_id, $meta_key, $_meta_value );
  
! 	return $mid;
  }
  
  /**
***************
*** 113,118 ****
--- 115,121 ----
  
  	// expected_slashed ($meta_key)
  	$meta_key = stripslashes($meta_key);
+ 	$passed_value = $meta_value;
  	$meta_value = stripslashes_deep($meta_value);
  	$meta_value = sanitize_meta( $meta_key, $meta_value, $meta_type );
  
***************
*** 121,127 ****
  		return (bool) $check;
  
  	if ( ! $meta_id = $wpdb->get_var( $wpdb->prepare( "SELECT $id_column FROM $table WHERE meta_key = %s AND $column = %d", $meta_key, $object_id ) ) )
! 		return add_metadata($meta_type, $object_id, $meta_key, $meta_value);
  
  	// Compare existing value to new value if no prev value given and the key exists only once.
  	if ( empty($prev_value) ) {
--- 124,130 ----
  		return (bool) $check;
  
  	if ( ! $meta_id = $wpdb->get_var( $wpdb->prepare( "SELECT $id_column FROM $table WHERE meta_key = %s AND $column = %d", $meta_key, $object_id ) ) )
! 		return add_metadata($meta_type, $object_id, $meta_key, $passed_value);
  
  	// Compare existing value to new value if no prev value given and the key exists only once.
  	if ( empty($prev_value) ) {
***************
*** 145,158 ****
  
  	do_action( "update_{$meta_type}_meta", $meta_id, $object_id, $meta_key, $_meta_value );
  
  	$wpdb->update( $table, $data, $where );
  	wp_cache_delete($object_id, $meta_type . '_meta');
- 	// users cache stores usermeta that must be cleared.
- 	if ( 'user' == $meta_type )
- 		clean_user_cache($object_id);
  
  	do_action( "updated_{$meta_type}_meta", $meta_id, $object_id, $meta_key, $_meta_value );
  
  	return true;
  }
  
--- 148,165 ----
  
  	do_action( "update_{$meta_type}_meta", $meta_id, $object_id, $meta_key, $_meta_value );
  
+ 	if ( 'post' == $meta_type )
+ 		do_action( 'update_postmeta', $meta_id, $object_id, $meta_key, $meta_value );
+ 
  	$wpdb->update( $table, $data, $where );
+ 
  	wp_cache_delete($object_id, $meta_type . '_meta');
  
  	do_action( "updated_{$meta_type}_meta", $meta_id, $object_id, $meta_key, $_meta_value );
  
+ 	if ( 'post' == $meta_type )
+ 		do_action( 'updated_postmeta', $meta_id, $object_id, $meta_key, $meta_value );
+ 
  	return true;
  }
  
***************
*** 211,218 ****
--- 218,231 ----
  	if ( !count( $meta_ids ) )
  		return false;
  
+ 	if ( $delete_all )
+ 		$object_ids = $wpdb->get_col( $wpdb->prepare( "SELECT $type_column FROM $table WHERE meta_key = %s", $meta_key ) );
+ 
  	do_action( "delete_{$meta_type}_meta", $meta_ids, $object_id, $meta_key, $_meta_value );
  
+ 	if ( 'post' == $meta_type )
+ 		do_action( 'delete_postmeta', $meta_ids );
+ 
  	$query = "DELETE FROM $table WHERE $id_column IN( " . implode( ',', $meta_ids ) . " )";
  
  	$count = $wpdb->query($query);
***************
*** 220,232 ****
  	if ( !$count )
  		return false;
  
! 	wp_cache_delete($object_id, $meta_type . '_meta');
! 	// users cache stores usermeta that must be cleared.
! 	if ( 'user' == $meta_type )
! 		clean_user_cache($object_id);
  
  	do_action( "deleted_{$meta_type}_meta", $meta_ids, $object_id, $meta_key, $_meta_value );
  
  	return true;
  }
  
--- 233,251 ----
  	if ( !$count )
  		return false;
  
! 	if ( $delete_all ) {
! 		foreach ( (array) $object_ids as $o_id ) {
! 			wp_cache_delete($o_id, $meta_type . '_meta');
! 		}
! 	} else {
! 		wp_cache_delete($object_id, $meta_type . '_meta');
! 	}
  
  	do_action( "deleted_{$meta_type}_meta", $meta_ids, $object_id, $meta_key, $_meta_value );
  
+ 	if ( 'post' == $meta_type )
+ 		do_action( 'deleted_postmeta', $meta_ids );
+ 
  	return true;
  }
  
***************
*** 282,287 ****
--- 301,513 ----
  }
  
  /**
+  * Determine if a meta key is set for a given object
+  *
+  * @since 3.3.0
+  *
+  * @param string $meta_type Type of object metadata is for (e.g., comment, post, or user)
+  * @param int $object_id ID of the object metadata is for
+  * @param string $meta_key Metadata key.
+  * @return boolean true of the key is set, false if not.
+  */
+ function metadata_exists( $meta_type, $object_id, $meta_key ) {
+ 	if ( ! $meta_type )
+ 		return false;
+ 
+ 	if ( ! $object_id = absint( $object_id ) )
+ 		return false;
+ 
+ 	$check = apply_filters( "get_{$meta_type}_metadata", null, $object_id, $meta_key, true );
+ 	if ( null !== $check )
+ 		return true;
+ 
+ 	$meta_cache = wp_cache_get( $object_id, $meta_type . '_meta' );
+ 
+ 	if ( !$meta_cache ) {
+ 		$meta_cache = update_meta_cache( $meta_type, array( $object_id ) );
+ 		$meta_cache = $meta_cache[$object_id];
+ 	}
+ 
+ 	if ( isset( $meta_cache[ $meta_key ] ) )
+ 		return true;
+ 
+ 	return false;
+ }
+ 
+ /**
+  * Get meta data by meta ID
+  *
+  * @since 3.3.0
+  *
+  * @param string $meta_type Type of object metadata is for (e.g., comment, post, or user)
+  * @param int $meta_id ID for a specific meta row
+  * @return object Meta object or false.
+  */
+ function get_metadata_by_mid( $meta_type, $meta_id ) {
+ 	global $wpdb;
+ 
+ 	if ( ! $meta_type )
+ 		return false;
+ 
+ 	if ( !$meta_id = absint( $meta_id ) )
+ 		return false;
+ 
+ 	if ( ! $table = _get_meta_table($meta_type) )
+ 		return false;
+ 
+ 	$id_column = ( 'user' == $meta_type ) ? 'umeta_id' : 'meta_id';
+ 
+ 	$meta = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM $table WHERE $id_column = %d", $meta_id ) );
+ 
+ 	if ( empty( $meta ) )
+ 		return false;
+ 
+ 	if ( isset( $meta->meta_value ) )
+ 		$meta->meta_value = maybe_unserialize( $meta->meta_value );
+ 
+ 	return $meta;
+ }
+ 
+ /**
+  * Update meta data by meta ID
+  *
+  * @since 3.3.0
+  *
+  * @uses get_metadata_by_mid() Calls get_metadata_by_mid() to fetch the meta key, value
+  *		and object_id of the given meta_id.
+  *
+  * @param string $meta_type Type of object metadata is for (e.g., comment, post, or user)
+  * @param int $meta_id ID for a specific meta row
+  * @param string $meta_value Metadata value
+  * @param string $meta_key Optional, you can provide a meta key to update it
+  * @return bool True on successful update, false on failure.
+  */
+ function update_metadata_by_mid( $meta_type, $meta_id, $meta_value, $meta_key = false ) {
+ 	global $wpdb;
+ 
+ 	// Make sure everything is valid.
+ 	if ( ! $meta_type )
+ 		return false;
+ 
+ 	if ( ! $meta_id = absint( $meta_id ) )
+ 		return false;
+ 
+ 	if ( ! $table = _get_meta_table( $meta_type ) )
+ 		return false;
+ 
+ 	$column = esc_sql($meta_type . '_id');
+ 	$id_column = 'user' == $meta_type ? 'umeta_id' : 'meta_id';
+ 
+ 	// Fetch the meta and go on if it's found.
+ 	if ( $meta = get_metadata_by_mid( $meta_type, $meta_id ) ) {
+ 		$original_key = $meta->meta_key;
+ 		$original_value = $meta->meta_value;
+ 		$object_id = $meta->{$column};
+ 
+ 		// If a new meta_key (last parameter) was specified, change the meta key,
+ 		// otherwise use the original key in the update statement.
+ 		if ( false === $meta_key ) {
+ 			$meta_key = $original_key;
+ 		} elseif ( ! is_string( $meta_key ) ) {
+ 			return false;
+ 		}
+ 
+ 		// Sanitize the meta
+ 		$_meta_value = $meta_value;
+ 		$meta_value = sanitize_meta( $meta_key, $meta_value, $meta_type );
+ 		$meta_value = maybe_serialize( $meta_value );
+ 
+ 		// Format the data query arguments.
+ 		$data = array(
+ 			'meta_key' => $meta_key,
+ 			'meta_value' => $meta_value
+ 		);
+ 
+ 		// Format the where query arguments.
+ 		$where = array();
+ 		$where[$id_column] = $meta_id;
+ 
+ 		do_action( "update_{$meta_type}_meta", $meta_id, $object_id, $meta_key, $_meta_value );
+ 
+ 		if ( 'post' == $meta_type )
+ 			do_action( 'update_postmeta', $meta_id, $object_id, $meta_key, $meta_value );
+ 
+ 		// Run the update query, all fields in $data are %s, $where is a %d.
+ 		$result = (bool) $wpdb->update( $table, $data, $where, '%s', '%d' );
+ 
+ 		// Clear the caches.
+ 		wp_cache_delete($object_id, $meta_type . '_meta');
+ 
+ 		do_action( "updated_{$meta_type}_meta", $meta_id, $object_id, $meta_key, $_meta_value );
+ 
+ 		if ( 'post' == $meta_type )
+ 			do_action( 'updated_postmeta', $meta_id, $object_id, $meta_key, $meta_value );
+ 
+ 		return $result;
+ 	}
+ 
+ 	// And if the meta was not found.
+ 	return false;
+ }
+ 
+ /**
+  * Delete meta data by meta ID
+  *
+  * @since 3.3.0
+  *
+  * @uses get_metadata_by_mid() Calls get_metadata_by_mid() to fetch the meta key, value
+  *		and object_id of the given meta_id.
+  *
+  * @param string $meta_type Type of object metadata is for (e.g., comment, post, or user)
+  * @param int $meta_id ID for a specific meta row
+  * @return bool True on successful delete, false on failure.
+  */
+ function delete_metadata_by_mid( $meta_type, $meta_id ) {
+ 	global $wpdb;
+ 
+ 	// Make sure everything is valid.
+ 	if ( ! $meta_type )
+ 		return false;
+ 
+ 	if ( ! $meta_id = absint( $meta_id ) )
+ 		return false;
+ 
+ 	if ( ! $table = _get_meta_table( $meta_type ) )
+ 		return false;
+ 
+ 	// object and id columns
+ 	$column = esc_sql($meta_type . '_id');
+ 	$id_column = 'user' == $meta_type ? 'umeta_id' : 'meta_id';
+ 
+ 	// Fetch the meta and go on if it's found.
+ 	if ( $meta = get_metadata_by_mid( $meta_type, $meta_id ) ) {
+ 		$object_id = $meta->{$column};
+ 
+ 		do_action( "delete_{$meta_type}_meta", (array) $meta_id, $object_id, $meta->meta_key, $meta->meta_value );
+ 
+ 		if ( 'post' == $meta_type )
+ 			do_action( 'delete_postmeta', $meta_id );
+ 
+ 		// Run the query, will return true if deleted, false otherwise
+ 		$result = (bool) $wpdb->query( $wpdb->prepare( "DELETE FROM $table WHERE $id_column = %d LIMIT 1;", $meta_id ) );
+ 
+ 		// Clear the caches.
+ 		wp_cache_delete($object_id, $meta_type . '_meta');
+ 
+ 		do_action( "deleted_{$meta_type}_meta", (array) $meta_id, $object_id, $meta->meta_key, $meta->meta_value );
+ 
+ 		if ( 'post' == $meta_type )
+ 			do_action( 'deleted_postmeta', $meta_id );
+ 
+ 		return $result;
+ 
+ 	}
+ 
+ 	// Meta id was not found.
+ 	return false;
+ }
+ 
+ /**
   * Update the metadata cache for the specified objects.
   *
   * @since 2.9.0
***************
*** 361,374 ****
   *
   * @see WP_Meta_Query
   *
!  * @param array (optional) $meta_query A meta query
   * @param string $type Type of meta
   * @param string $primary_table
   * @param string $primary_id_column
   * @param object $context (optional) The main query object
   * @return array( 'join' => $join_sql, 'where' => $where_sql )
   */
! function get_meta_sql( $meta_query = false, $type, $primary_table, $primary_id_column, $context = null ) {
  	$meta_query_obj = new WP_Meta_Query( $meta_query );
  	return $meta_query_obj->get_sql( $type, $primary_table, $primary_id_column, $context );
  }
--- 587,600 ----
   *
   * @see WP_Meta_Query
   *
!  * @param array $meta_query A meta query
   * @param string $type Type of meta
   * @param string $primary_table
   * @param string $primary_id_column
   * @param object $context (optional) The main query object
   * @return array( 'join' => $join_sql, 'where' => $where_sql )
   */
! function get_meta_sql( $meta_query, $type, $primary_table, $primary_id_column, $context = null ) {
  	$meta_query_obj = new WP_Meta_Query( $meta_query );
  	return $meta_query_obj->get_sql( $type, $primary_table, $primary_id_column, $context );
  }
***************
*** 408,414 ****
  	/**
  	 * Constructor
  	 *
! 	 * @param array (optional) $meta_query A meta query
  	 */
  	function __construct( $meta_query = false ) {
  		if ( !$meta_query )
--- 634,640 ----
  	/**
  	 * Constructor
  	 *
! 	 * @param array $meta_query (optional) A meta query
  	 */
  	function __construct( $meta_query = false ) {
  		if ( !$meta_query )
***************
*** 483,494 ****
  
  		foreach ( $this->queries as $k => $q ) {
  			$meta_key = isset( $q['key'] ) ? trim( $q['key'] ) : '';
- 			$meta_compare = isset( $q['compare'] ) ? strtoupper( $q['compare'] ) : '=';
  			$meta_type = isset( $q['type'] ) ? strtoupper( $q['type'] ) : 'CHAR';
  
- 			if ( ! in_array( $meta_compare, array( '=', '!=', '>', '>=', '<', '<=', 'LIKE', 'NOT LIKE', 'IN', 'NOT IN', 'BETWEEN', 'NOT BETWEEN' ) ) )
- 				$meta_compare = '=';
- 
  			if ( 'NUMERIC' == $meta_type )
  				$meta_type = 'SIGNED';
  			elseif ( ! in_array( $meta_type, array( 'BINARY', 'CHAR', 'DATE', 'DATETIME', 'DECIMAL', 'SIGNED', 'TIME', 'UNSIGNED' ) ) )
--- 709,716 ----
***************
*** 514,519 ****
--- 736,748 ----
  
  			$meta_value = $q['value'];
  
+ 			$meta_compare = is_array( $meta_value ) ? 'IN' : '=';
+ 			if ( isset( $q['compare'] ) )
+ 				$meta_compare = strtoupper( $q['compare'] );
+ 
+ 			if ( ! in_array( $meta_compare, array( '=', '!=', '>', '>=', '<', '<=', 'LIKE', 'NOT LIKE', 'IN', 'NOT IN', 'BETWEEN', 'NOT BETWEEN' ) ) )
+ 				$meta_compare = '=';
+ 
  			if ( in_array( $meta_compare, array( 'IN', 'NOT IN', 'BETWEEN', 'NOT BETWEEN' ) ) ) {
  				if ( ! is_array( $meta_value ) )
  					$meta_value = preg_split( '/[,\s]+/', $meta_value );
***************
*** 588,594 ****
   * @return bool True if the key is protected, false otherwise.
   */
  function is_protected_meta( $meta_key, $meta_type = null ) {
! 	$protected = (  '_' == $meta_key[0] );
  
  	return apply_filters( 'is_protected_meta', $protected, $meta_key, $meta_type );
  }
--- 817,823 ----
   * @return bool True if the key is protected, false otherwise.
   */
  function is_protected_meta( $meta_key, $meta_type = null ) {
! 	$protected = ( '_' == $meta_key[0] );
  
  	return apply_filters( 'is_protected_meta', $protected, $meta_key, $meta_type );
  }
***************
*** 603,610 ****
   * @param string $meta_type Type of meta
   * @return mixed Sanitized $meta_value
   */
! function sanitize_meta( $meta_key, $meta_value, $meta_type = null ) {
! 	return apply_filters( 'sanitize_meta', $meta_value, $meta_key, $meta_type );
  }
  
  ?>
--- 832,865 ----
   * @param string $meta_type Type of meta
   * @return mixed Sanitized $meta_value
   */
! function sanitize_meta( $meta_key, $meta_value, $meta_type ) {
! 	return apply_filters( "sanitize_{$meta_type}_meta_{$meta_key}", $meta_value, $meta_key, $meta_type );
! }
! 
! /**
!  * Register meta key
!  *
!  * @since 3.3.0
!  *
!  * @param string $meta_type Type of meta
!  * @param string $meta_key Meta key
!  * @param string|array $sanitize_callback A function or method to call when sanitizing the value of $meta_key.
!  * @param string|array $auth_callback Optional. A function or method to call when performing edit_post_meta, add_post_meta, and delete_post_meta capability checks.
!  * @param array $args Arguments
!  */
! function register_meta( $meta_type, $meta_key, $sanitize_callback, $auth_callback = null ) {
! 	if ( is_callable( $sanitize_callback ) )
! 		add_filter( "sanitize_{$meta_type}_meta_{$meta_key}", $sanitize_callback, 10, 3 );
! 
! 	if ( empty( $auth_callback ) ) {
! 		if ( is_protected_meta( $meta_key, $meta_type ) )
! 			$auth_callback = '__return_false';
! 		else
! 			$auth_callback = '__return_true';
! 	}
! 
! 	if ( is_callable( $auth_callback ) )
! 		add_filter( "auth_{$meta_type}_meta_{$meta_key}", $auth_callback, 10, 6 );
  }
  
  ?>
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/ms-blogs.php ./wordpress-3.3/wp-includes/ms-blogs.php
*** ./wordpress-3.2.1/wp-includes/ms-blogs.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/ms-blogs.php	2011-11-03 12:06:45.000000000 -0500
***************
*** 16,25 ****
  function wpmu_update_blogs_date() {
  	global $wpdb;
  
! 	// TODO: use update_blog_details
! 
! 	$wpdb->update( $wpdb->blogs, array('last_updated' => current_time('mysql', true)), array('blog_id' => $wpdb->blogid) );
! 	refresh_blog_details( $wpdb->blogid );
  
  	do_action( 'wpmu_blog_updated', $wpdb->blogid );
  }
--- 16,22 ----
  function wpmu_update_blogs_date() {
  	global $wpdb;
  
! 	update_blog_details( $wpdb->blogid, array('last_updated' => current_time('mysql', true)) );
  
  	do_action( 'wpmu_blog_updated', $wpdb->blogid );
  }
***************
*** 323,329 ****
   * @since MU
   * @uses apply_filters() Calls 'blog_option_$optionname' with the option name value.
   *
!  * @param int $blog_id is the id of the blog.
   * @param string $setting Name of option to retrieve. Should already be SQL-escaped.
   * @param string $default (optional) Default value returned if option not found.
   * @return mixed Value set for the option.
--- 320,326 ----
   * @since MU
   * @uses apply_filters() Calls 'blog_option_$optionname' with the option name value.
   *
!  * @param int $blog_id Optional. Blog ID, can be null to refer to the current blog.
   * @param string $setting Name of option to retrieve. Should already be SQL-escaped.
   * @param string $default (optional) Default value returned if option not found.
   * @return mixed Value set for the option.
***************
*** 331,336 ****
--- 328,336 ----
  function get_blog_option( $blog_id, $setting, $default = false ) {
  	global $wpdb;
  
+ 	if ( null === $blog_id )
+ 		$blog_id = $wpdb->blogid;
+ 
  	$key = $blog_id . '-' . $setting . '-blog_option';
  	$value = wp_cache_get( $key, 'site-options' );
  	if ( $value == null ) {
***************
*** 383,396 ****
   * @param int $id The blog id
   * @param string $key The option key
   * @param mixed $value The option value
   */
  function add_blog_option( $id, $key, $value ) {
  	$id = (int) $id;
  
  	switch_to_blog($id);
! 	add_option( $key, $value );
  	restore_current_blog();
! 	wp_cache_set( $id . '-' . $key . '-blog_option', $value, 'site-options' );
  }
  
  /**
--- 383,399 ----
   * @param int $id The blog id
   * @param string $key The option key
   * @param mixed $value The option value
+  * @return bool True on success, false on failure.
   */
  function add_blog_option( $id, $key, $value ) {
  	$id = (int) $id;
  
  	switch_to_blog($id);
! 	$return = add_option( $key, $value );
  	restore_current_blog();
! 	if ( $return )
! 		wp_cache_set( $id . '-' . $key . '-blog_option', $value, 'site-options' );
! 	return $return;
  }
  
  /**
***************
*** 400,413 ****
   *
   * @param int $id The blog id
   * @param string $key The option key
   */
  function delete_blog_option( $id, $key ) {
  	$id = (int) $id;
  
  	switch_to_blog($id);
! 	delete_option( $key );
  	restore_current_blog();
! 	wp_cache_set( $id . '-' . $key . '-blog_option', '', 'site-options' );
  }
  
  /**
--- 403,419 ----
   *
   * @param int $id The blog id
   * @param string $key The option key
+  * @return bool True on success, false on failure.
   */
  function delete_blog_option( $id, $key ) {
  	$id = (int) $id;
  
  	switch_to_blog($id);
! 	$return = delete_option( $key );
  	restore_current_blog();
! 	if ( $return )
! 		wp_cache_set( $id . '-' . $key . '-blog_option', '', 'site-options' );
! 	return $return;
  }
  
  /**
***************
*** 418,423 ****
--- 424,430 ----
   * @param int $id The blog id
   * @param string $key The option key
   * @param mixed $value The option value
+  * @return bool True on success, false on failrue.
   */
  function update_blog_option( $id, $key, $value, $deprecated = null ) {
  	$id = (int) $id;
***************
*** 426,437 ****
  		_deprecated_argument( __FUNCTION__, '3.1' );
  
  	switch_to_blog($id);
! 	update_option( $key, $value );
  	restore_current_blog();
  
  	refresh_blog_details( $id );
  
! 	wp_cache_set( $id . '-' . $key . '-blog_option', $value, 'site-options');
  }
  
  /**
--- 433,446 ----
  		_deprecated_argument( __FUNCTION__, '3.1' );
  
  	switch_to_blog($id);
! 	$return = update_option( $key, $value );
  	restore_current_blog();
  
  	refresh_blog_details( $id );
  
! 	if ( $return )
! 		wp_cache_set( $id . '-' . $key . '-blog_option', $value, 'site-options');
! 	return $return;
  }
  
  /**
***************
*** 678,681 ****
--- 687,712 ----
  	return $wpdb->get_results( $wpdb->prepare("SELECT blog_id, domain, path FROM $wpdb->blogs WHERE site_id = %d AND public = '1' AND archived = '0' AND mature = '0' AND spam = '0' AND deleted = '0' AND last_updated != '0000-00-00 00:00:00' ORDER BY last_updated DESC limit %d, %d", $wpdb->siteid, $start, $quantity ) , ARRAY_A );
  }
  
+ /**
+  * Handler for updating the blog date when a post is published or an already published post is changed.
+  *
+  * @since 3.3.0
+  *
+  * @param string $new_status The new post status
+  * @param string $old_status The old post status
+  * @param object $post Post object
+  */
+ function _update_blog_date_on_post_publish( $new_status, $old_status, $post ) {
+ 	$post_type_obj = get_post_type_object( $post->post_type );
+ 	if ( ! $post_type_obj->public )
+ 		return;
+ 
+ 	if ( 'publish' != $new_status && 'publish' != $old_status )
+ 		return;
+ 
+ 	// Post was freshly published, published post was saved, or published post was unpublished.
+ 
+ 	wpmu_update_blogs_date();
+ }
+ 
  ?>
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/ms-default-filters.php ./wordpress-3.3/wp-includes/ms-default-filters.php
*** ./wordpress-3.2.1/wp-includes/ms-default-filters.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/ms-default-filters.php	2011-11-03 12:06:45.000000000 -0500
***************
*** 36,44 ****
  add_filter( 'term_id_filter', 'global_terms', 10, 2 );
  add_action( 'publish_post', 'update_posts_count' );
  add_action( 'delete_post', 'wpmu_update_blogs_date' );
! add_action( 'private_to_published', 'wpmu_update_blogs_date' );
! add_action( 'publish_phone', 'wpmu_update_blogs_date' );
! add_action( 'publish_post', 'wpmu_update_blogs_date' );
  add_action( 'admin_init', 'wp_schedule_update_network_counts');
  add_action( 'update_network_counts', 'wp_update_network_counts');
  
--- 36,42 ----
  add_filter( 'term_id_filter', 'global_terms', 10, 2 );
  add_action( 'publish_post', 'update_posts_count' );
  add_action( 'delete_post', 'wpmu_update_blogs_date' );
! add_action( 'transition_post_status', '_update_blog_date_on_post_publish', 10, 3 );
  add_action( 'admin_init', 'wp_schedule_update_network_counts');
  add_action( 'update_network_counts', 'wp_update_network_counts');
  
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/ms-deprecated.php ./wordpress-3.3/wp-includes/ms-deprecated.php
*** ./wordpress-3.2.1/wp-includes/ms-deprecated.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/ms-deprecated.php	2011-09-30 10:13:13.000000000 -0500
***************
*** 68,74 ****
  	_deprecated_function( __FUNCTION__, '3.0', 'wp_die()' );
  	$message = apply_filters( 'graceful_fail', $message );
  	$message_template = apply_filters( 'graceful_fail_template',
! '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
  <html xmlns="http://www.w3.org/1999/xhtml"><head profile="http://gmpg.org/xfn/11">
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  <title>Error!</title>
--- 68,74 ----
  	_deprecated_function( __FUNCTION__, '3.0', 'wp_die()' );
  	$message = apply_filters( 'graceful_fail', $message );
  	$message_template = apply_filters( 'graceful_fail_template',
! '<!DOCTYPE html>
  <html xmlns="http://www.w3.org/1999/xhtml"><head profile="http://gmpg.org/xfn/11">
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  <title>Error!</title>
***************
*** 200,203 ****
  	}
  	return array_slice( $most_active, 0, $num );
  }
! ?>
--- 200,274 ----
  	}
  	return array_slice( $most_active, 0, $num );
  }
! 
! /**
!  * Redirect a user based on $_GET or $_POST arguments.
!  *
!  * The function looks for redirect arguments in the following order:
!  * 1) $_GET['ref']
!  * 2) $_POST['ref']
!  * 3) $_SERVER['HTTP_REFERER']
!  * 4) $_GET['redirect']
!  * 5) $_POST['redirect']
!  * 6) $url
!  *
!  * @since MU
!  * @deprecated 3.3.0
!  * @deprecated Use wp_redirect()
!  * @uses wpmu_admin_redirect_add_updated_param()
!  *
!  * @param string $url
!  */
! function wpmu_admin_do_redirect( $url = '' ) {
! 	_deprecated_function( __FUNCTION__, '3.3' );
! 
! 	$ref = '';
! 	if ( isset( $_GET['ref'] ) )
! 		$ref = $_GET['ref'];
! 	if ( isset( $_POST['ref'] ) )
! 		$ref = $_POST['ref'];
! 
! 	if ( $ref ) {
! 		$ref = wpmu_admin_redirect_add_updated_param( $ref );
! 		wp_redirect( $ref );
! 		exit();
! 	}
! 	if ( empty( $_SERVER['HTTP_REFERER'] ) == false ) {
! 		wp_redirect( $_SERVER['HTTP_REFERER'] );
! 		exit();
! 	}
! 
! 	$url = wpmu_admin_redirect_add_updated_param( $url );
! 	if ( isset( $_GET['redirect'] ) ) {
! 		if ( substr( $_GET['redirect'], 0, 2 ) == 's_' )
! 			$url .= '&action=blogs&s='. esc_html( substr( $_GET['redirect'], 2 ) );
! 	} elseif ( isset( $_POST['redirect'] ) ) {
! 		$url = wpmu_admin_redirect_add_updated_param( $_POST['redirect'] );
! 	}
! 	wp_redirect( $url );
! 	exit();
! }
! 
! /**
!  * Adds an 'updated=true' argument to a URL.
!  *
!  * @since MU
!  * @deprecated 3.3.0
!  * @deprecated Use add_query_arg()
!  *
!  * @param string $url
!  * @return string
!  */
! function wpmu_admin_redirect_add_updated_param( $url = '' ) {
! 	_deprecated_function( __FUNCTION__, '3.3' );
! 
! 	if ( strpos( $url, 'updated=true' ) === false ) {
! 		if ( strpos( $url, '?' ) === false )
! 			return $url . '?updated=true';
! 		else
! 			return $url . '&updated=true';
! 	}
! 	return $url;
! }
! 
! ?>
\ No newline at end of file
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/ms-files.php ./wordpress-3.3/wp-includes/ms-files.php
*** ./wordpress-3.2.1/wp-includes/ms-files.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/ms-files.php	2011-09-06 10:41:57.000000000 -0500
***************
*** 23,29 ****
  	die( '404 &#8212; File not found.' );
  }
  
! $file = BLOGUPLOADDIR . str_replace( '..', '', $_GET[ 'file' ] );
  if ( !is_file( $file ) ) {
  	status_header( 404 );
  	die( '404 &#8212; File not found.' );
--- 23,29 ----
  	die( '404 &#8212; File not found.' );
  }
  
! $file = rtrim( BLOGUPLOADDIR, '/' ) . '/' . str_replace( '..', '', $_GET[ 'file' ] );
  if ( !is_file( $file ) ) {
  	status_header( 404 );
  	die( '404 &#8212; File not found.' );
